#include "Grid.hpp"

//Constructor
Grid::Grid(int size)
{
	//Create Vector
	m_size = size;
	m_table = std::vector<std::vector<Cell<StringElement>*> >(size);

	//Init all of line and cell
	for(int i = 0 ; i < size ; i++)
	{
		m_table[i] = std::vector<Cell<StringElement>*>(size);
		for (int j = 0 ; j < size ; j++)
		{
			Cell<StringElement> * cell = new Cell<StringElement>("");
			m_table[i][j] = cell;
		}
	}
}

//Destructor
Grid::~Grid()
{
	for(int i = 0 ; i < m_size ; i++)
	{
		for(int j = 0 ; j < m_size ; j++)
			delete m_table[i][j];
	}
}

void Grid::show()
{
	std::cout << "_________________" << std::endl;
	std::cout << std::endl;
	for(int i = 0 ; i < m_size ; i++)
	{
		std::cout << "|";
		for(int j = 0 ; j < m_size ; j++)
		{
			std::cout << " " << m_table[i][j]->description() << " |";
		}
		std::cout << std::endl;

		if (i != m_size -1)
			std::cout << std::endl;
	}
	std::cout << "_________________" << std::endl;
}

bool Grid::isEmpty(int i, int j)
{
	if (i >= 0 && i < m_size && j >= 0 && j < m_size)
		return m_table[i][j]->isEmpty();

	return false;
}

bool Grid::gridIsFull()
{

	for (int i = 0; i < m_size ; i++)
	{
		for (int j = 0; j < m_size ; j++)
		{
			if (m_table[i][j]->isEmpty())
				return false;
		}
	}

	return true;
}

void Grid::setCell(int i, int j, Cell<StringElement> *cell)
{
	if (i >= 0 && i < m_size && j >= 0 && j < m_size)
	{
		delete m_table[i][j];
		m_table[i][j] = cell;
	}
}

Cell<StringElement>* Grid::getCell(short i, short j){
	return m_table[i][j];
}

int Grid::getNRows(){
	return m_table[0].size();
}

int Grid::getNCols(){
	return m_table.size();
}


std::vector<Cell<StringElement>* > Grid::swipeLine(std::vector<Cell<StringElement>* > line){
	std::vector<Cell<StringElement>*> newLine = std::vector<Cell<StringElement>*>(4);


	for (int j = 0 ; j < 3 ; j++)
	{
		if(j>3)
			break;
		Cell<StringElement> * cell = new Cell<StringElement>(line.at(j)->getElementValue());
		Cell<StringElement> * cellp1 = new Cell<StringElement>(line.at(j+1)->getElementValue());

		int a=atoi(cell->getElementValue().c_str());
		int ap1=atoi(cellp1->getElementValue().c_str());

		std::string s=std::to_string(a);
		std::string sp1=std::to_string(ap1);

		if(a==ap1 && a!=0){
			s="";
			sp1=std::to_string(a+ap1);
			if(ap1 == 0)
				newLine[j+1] = new Cell<StringElement>("");
			else
				newLine[j+1] = new Cell<StringElement>(sp1);
			newLine[j] = new Cell<StringElement>(s);
			j++;
		}
		else{
			if(ap1==0)
				newLine[j+1] = new Cell<StringElement>("");
			else
				newLine[j+1] = new Cell<StringElement>(sp1);
			if(a==0)
				newLine[j] = new Cell<StringElement>("");
			else
				newLine[j] = new Cell<StringElement>(s);

		}
		delete cell;
		delete cellp1;
		
	}


	for (int j = 0 ; j < 3 ; j++){

		if(!newLine[j]->isEmpty()){
			if(newLine[j+1]->isEmpty()){
				newLine[j+1]=new Cell<StringElement>(newLine[j]->getElementValue());
				newLine[j]=new Cell<StringElement>("");
			}
		}
	}

	for(int i=0; i<4;i++){

		std::cout << "|" << newLine[i]->description() << "|";
	}
	std::cout << "done";
	return newLine;
}

void Grid::swipeRight(){
	std::vector<Cell<StringElement>*> a=this->swipeLine(m_table.at(0));
	m_table[0]=a;
}
